"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const dynamic_1 = __importDefault(require("next/dynamic"));
const BASE_DIR = '/svg/';
const getFillColor = (color) => color || 'currentColor';
const normalizeSubdirectory = (subdirectory) => {
    if (!subdirectory) {
        return '';
    }
    const newSubDirectory = subdirectory.startsWith('/') ? subdirectory.slice(1) : subdirectory;
    return newSubDirectory.endsWith('/') ? newSubDirectory : `${newSubDirectory}/`;
};
const normalizeName = (name) => name.replace('.svg', '');
const assembleDirectory = (name, subdirectory) => `${BASE_DIR}${normalizeSubdirectory(subdirectory)}${normalizeName(name)}.svg`;
const Svg = ({ name, alt, className, color, height, subdirectory, width }) => {
    const svgDirectory = assembleDirectory(name, subdirectory);
    try {
        const SvgImage = ((0, dynamic_1.default)(() => Promise.resolve(`${svgDirectory}`).then(s => __importStar(require(s)))));
        const divStyle = color || width || height ? {
            ...(color && { color }),
            ...(width && { width }),
            ...(width && { maxWidth: width }),
            ...(width && { minWidth: width }),
            ...(height && { height }),
            ...(height && { maxHeight: height }),
            ...(height && { minHeight: height })
        } : undefined;
        return (react_1.default.createElement("div", { className: className, style: divStyle },
            react_1.default.createElement(SvgImage, { fill: getFillColor(color) })));
    }
    catch (e) {
        return alt;
    }
};
exports.default = Svg;
